Bug 1913266 - mkdocs fails to build with Python 3.10: RuntimeError: 'auto_spec' might be a typo; use unsafe=True if this is intended
Summary: mkdocs fails to build with Python 3.10: RuntimeError: 'auto_spec' might be a ...
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: mkdocs
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Robin Lee
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2021-01-06 11:49 UTC by Tomáš Hrnčiar
Modified: 2021-02-17 15:36 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2021-01-06 11:49:21 UTC
mkdocs fails to build with Python 3.10.0a4.

======================================================================
ERROR: tests.utils.ghp_import_tests (unittest.loader._FailedTest)
----------------------------------------------------------------------
ImportError: Failed to import test module: tests.utils.ghp_import_tests
Traceback (most recent call last):
  File "/usr/lib64/python3.10/unittest/loader.py", line 436, in _find_test_path
    module = self._get_module_from_name(name)
  File "/usr/lib64/python3.10/unittest/loader.py", line 377, in _get_module_from_name
    __import__(name)
  File "/builddir/build/BUILD/mkdocs-1.1.2/mkdocs/tests/utils/ghp_import_tests.py", line 13, in <module>
    class UtilsTests(unittest.TestCase):
  File "/builddir/build/BUILD/mkdocs-1.1.2/mkdocs/tests/utils/ghp_import_tests.py", line 15, in UtilsTests
    @mock.patch('subprocess.call', auto_spec=True)
  File "/usr/lib64/python3.10/unittest/mock.py", line 1736, in patch
    return _patch(
  File "/usr/lib64/python3.10/unittest/mock.py", line 1275, in __init__
    _check_spec_arg_typos(kwargs)
  File "/usr/lib64/python3.10/unittest/mock.py", line 1251, in _check_spec_arg_typos
    raise RuntimeError(
RuntimeError: 'auto_spec' might be a typo; use unsafe=True if this is intended

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01859956-mkdocs/

For all our attempts to build mkdocs with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/mkdocs/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Ben Cotton 2021-02-09 15:37:26 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 34 development cycle.
Changing version to 34.

Comment 2 Karthikeyan Singaravelan 2021-02-17 15:36:09 UTC
The vendored copy of the file seems to have been removed in https://github.com/mkdocs/mkdocs/commit/5c2b4f13536009852046c89aadd63ac46eacbaaa and should fix the issue. This is due to some validations done from mock in Python 3.10 to catch typos : https://github.com/python/cpython/pull/23737


Note You need to log in before you can comment on or make changes to this bug.